package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.FacedInfo;
import com.izouma.awesomeadmin.service.FacedInfoService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/facedInfo")
public class FacedInfoController extends BaseController{

    @Autowired
    private FacedInfoService facedInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(FacedInfo record) {
        List<FacedInfo> pp = facedInfoService.getFacedInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getFacedInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getFacedInfo(@RequestParam(required = false, value = "id") String id) {
        FacedInfo data = facedInfoService.getFacedInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(FacedInfo record) {
        FacedInfo data = facedInfoService.getFacedInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, FacedInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<FacedInfo> pp =facedInfoService.getFacedInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(FacedInfo record) {
        boolean num = facedInfoService.createFacedInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateFacedInfo(FacedInfo record) {
        boolean num = facedInfoService.updateFacedInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteFacedInfo(@RequestParam(required = true, value = "id") String id) {

        boolean num = facedInfoService.deleteFacedInfo(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, FacedInfo record) throws Exception {

    List<FacedInfo> facedInfos = facedInfoService.getFacedInfoList(record);


        String sheetName = "faced_info";
        String titleName = "朝向数据表";
        String fileName = "朝向表";
        int columnNumber = 4;
        int[] columnWidth = { 20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "朝向" ,   "排序"  };
        String[][] dataList = new String[facedInfos.size()][4];

        for (int i = 0; i < facedInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(facedInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(facedInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(facedInfos.get(i).getFacedName());
                        dataList[i][3] = String.valueOf(facedInfos.get(i).getRank());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

